<?php
// $Id: weblinks_top.php,v 1.7 2006/05/24 13:22:59 ohwada Exp $

// 2006-05-15 K.OHWADA
// change $moduel_url to $dirname

// 2006-01-01 K.OHWADA
// weblinks ver 1.0
// module depulication

//=========================================================
// WebLinks Module
// 2004/01/14 K.OHWADA
//=========================================================

// --- block function begin ---
if( !function_exists( 'b_weblinks_top_show' ) ) 
{

//---------------------------------------------------------
// $options
// [0] module directory name (weblinks)
// [1] order (time_update/hits/rating)
// [2] number of display links (10)
// [3] max length of title (30)
//       when 0, unlimited
// [4] days to show new icon (7)
// [5] hits to show popular icon (0)
// [6] max width of banner image (50)
//       when 0, not show
// [7] default width of banner image (50)
//       when 0, use original size
//---------------------------------------------------------

function b_weblinks_top_show($options) 
{
	global $xoopsDB;

	$myts =& MyTextSanitizer::getInstance();

	$dirname = empty( $options[0] ) ? basename( dirname( dirname( __FILE__ ) ) ) : $options[0];
	$order     = $options[1];
	$limit     = $options[2];
	$max_title = $options[3];
	$newdays   = $options[4];
	$popular   = $options[5];
	$max_width = $options[6];
	$width_default = $options[7];

	$table_link = $xoopsDB->prefix( $dirname."_link" );

	$block = array();
	$block['dirname']       = $dirname;
	$block['lang_hits']     = _MB_WEBLINKS_HITS;
	$block['lang_rating']   = _MB_WEBLINKS_RATING;
	$block['lang_votes']    = _MB_WEBLINKS_VOTES;
	$block['lang_comments'] = _MB_WEBLINKS_COMMENTS;

	$sql    = "SELECT * FROM $table_link ORDER BY $order DESC";
	$result = $xoopsDB->query($sql, $limit, 0);

	while( $row = $xoopsDB->fetchArray($result) )
	{
		$link = array();

		$show_banner  = 0;
		$show_new     = 0;
		$show_update  = 0;
		$show_popular = 0;

		$lid    = $row['lid'];
		$title  = $row['title'];
		$url    = $row['url'];
		$banner = $row['banner'];
		$width  = $row['width'];
		$height = $row['height'];
		$hits   = $row['hits'];
		$rating = $row['rating'];
		$votes  = $row['votes'];
		$comments = $row['comments'];
		$time_create = $row['time_create'];
		$time_update = $row['time_update'];

// unlimited when $options[2] = 0 
		if ( ($max_title > 0) && (strlen( $title ) > $max_title) )
		{
			$title = strip_tags( $title );

// for multibyte environment
			if (function_exists('mb_strimwidth'))
			{
				$title = mb_strimwidth( $title, 0, $max_title, " ..." );
			}
			else
			{
				$title = substr( $title, 0, $max_title )." ...";
			}
		}

// banner image
		if ( ($max_width > 0) && $banner )
		{
			$show_banner = 1;

			if ($width > $max_width)
			{
				$width = $max_width;
			}

			if (($width == 0) && ($width_default > 0))
			{
				$width = $width_default;
			}
		}

// new & update image

		if ( $newdays > 0)
		{
			$startdate = (time()-(86400 * $newdays));

			if ( $startdate < $time_create ) 
			{
				$show_new = 1;
			}
			elseif ( $startdate < $time_update )
			{
				$show_update = 1;
			}
		}

// popular image
		if ($popular > 0)
		{
			if ( $row['hits'] >= $popular )
			{
				$show_popular = 1;
			}
		}

		$link['show_banner'] = $show_banner;
		$link['show_new']    = $show_new;
		$link['show_update'] = $show_update;
		$link['show_pop']    = $show_popular;
		$link['width']       = $width;

		$link['id']       = $lid;
		$link['hits']     = $hits;
		$link['votes']    = $votes;
		$link['comments'] = $comments;
		$link['url']      = htmlspecialchars($url,    ENT_QUOTES);
		$link['banner']   = htmlspecialchars($banner, ENT_QUOTES);
		$link['date']     = formatTimestamp($time_update,'s');
		$link['rates']    = sprintf("%.1f",$rating);
		$link['title']    = $myts->makeTboxData4Show( $title );

// old style
		if ($order == "rating")
		{
			$link['hits']  = $link['rates'];
		}

		$block['links'][] = $link;
	}

	return $block;
}

function b_weblinks_top_edit($options) 
{

	$dirname = empty( $options[0] ) ? basename( dirname( dirname( __FILE__ ) ) ) : $options[0];

	$form  = "<table><tr><td>";
	$form .= "Module Directory: ";
	$form .= "</td><td>";
	$form .= "$dirname ";
	$form .= "<input type='hidden' name='options[0]' value='".$dirname."' />\n";
	$form .= "</td></tr>\n<tr><td>";
	$form .= "Order: ";
	$form .= "</td><td>";
	$form .= "$options[1] ";
	$form .= "<input type='hidden' name='options[1]' value='".$options[1]."' />\n";
	$form .= "</td></tr>\n<tr><td>";
	$form .= _MB_WEBLINKS_DISP;
	$form .= "</td><td>";
	$form .= "<input type='text' name='options[2]' value='".$options[2]."' />&nbsp;"._MB_WEBLINKS_LINKS."";
	$form .= "</td></tr>\n<tr><td>";
	$form .= _MB_WEBLINKS_CHARS;
	$form .= "</td><td>";
	$form .= "<input type='text' name='options[3]' value='".$options[3]."' />&nbsp;"._MB_WEBLINKS_LENGTH."";
	$form .= "</td></tr>\n<tr><td>";
	$form .= _MB_WEBLINKS_NEWDAYS;
	$form .= "</td><td>";
	$form .= "<input type='text' name='options[4]' value='".$options[4]."' />&nbsp;"._MB_WEBLINKS_DAYS."";
	$form .= "</td></tr>\n<tr><td>";
	$form .= _MB_WEBLINKS_POPULAR;
	$form .= "</td><td>";
	$form .= "<input type='text' name='options[5]' value='".$options[5]."' />&nbsp;"._MB_WEBLINKS_HITS."";
	$form .= "</td></tr>\n<tr><td>";
	$form .= _MB_WEBLINKS_MAX_WIDTH;
	$form .= "</td><td>";
	$form .= "<input type='text' name='options[6]' value='".$options[6]."' />&nbsp;"._MB_WEBLINKS_PIXEL."";
	$form .= "</td></tr>\n<tr><td>";
	$form .= _MB_WEBLINKS_WIDTH_DEFAULT;
	$form .= "</td><td>";
	$form .= "<input type='text' name='options[7]' value='".$options[7]."' />&nbsp;"._MB_WEBLINKS_PIXEL."";
	$form .= "</td></tr></table>\n";
	return $form;

}

// --- block function begin end ---
}

?>