<?php
// $Id: gm_get_location.php,v 1.1 2006/10/05 11:11:46 ohwada Exp $

//================================================================
// WebLinks Module
// 2006-10-01 wye <http://never-ever.info/>
//================================================================

include "header.php";

$config_handler =& weblinks_get_handler( 'config2_basic', WEBLINKS_DIRNAME );
$conf = $config_handler->get_conf();

//---------------------------------------------------------
// Google Map Configurations
//---------------------------------------------------------
$gm_lang              = _LANGCODE;
$gm_apikey            = $conf['gm_apikey'];
$gm_server            = $conf['gm_server'];
$gm_default_latitude  = $conf['gm_latitude'];
$gm_default_longitude = $conf['gm_longitude'];
$gm_default_zoom      = $conf['gm_zoom'];
$gm_default_location  = happy_linux_convert_to_utf8( $conf['gm_location'] );

$gm_version = '2';
//---------------------------------------------------------

$gm_url = $gm_server.'maps?file=api&amp;hl='.$gm_lang.'&amp;v='.$gm_version.'&amp;key='.$gm_apikey;
$gm_lang_location = _WEBLINKS_GM_LATITUDE.': #lat# / '._WEBLINKS_GM_LONGITUDE.': #lng# / '._WEBLINKS_GM_ZOOM.': #zoom#';
$gm_lang_default_location = _WEBLINKS_GM_LATITUDE.': '.$gm_default_latitude.' / '._WEBLINKS_GM_LONGITUDE.': '.$gm_default_longitude.' / '._WEBLINKS_GM_ZOOM.': '.$gm_default_zoom;

$gm_lang_location         = happy_linux_convert_to_utf8( $gm_lang_location );
$gm_lang_default_location = happy_linux_convert_to_utf8( $gm_lang_default_location );

$lang_title            = happy_linux_convert_to_utf8( _WEBLINKS_GM_GET_LOCATION );
$lang_button           = happy_linux_convert_to_utf8( _WEBLINKS_GM_GET_BUTTON );
$lang_default_location = happy_linux_convert_to_utf8( _WEBLINKS_GM_DEFAULT_LOCATION );
$lang_current_location = happy_linux_convert_to_utf8( _WEBLINKS_GM_CURRENT_LOCATION );

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n";

if ($gm_apikey)
{
// --- raw HTML begin ---
?>
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:v="urn:schemas-microsoft-com:vml">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
<title>weblinks - <?php echo $lang_title; ?></title>
<style type="text/css">#map{ border:1px solid #999; }</style>
<script src="<?php echo $gm_url; ?>" type="text/javascript" charset="UTF-8"></script>
<script type="text/javascript">
//<![CDATA[
var gm_default_latitude = <?php echo $gm_default_latitude; ?>;
var gm_default_longitude = <?php echo $gm_default_longitude; ?>;
var gm_default_zoom = <?php echo $gm_default_zoom; ?>;
var gm_lang_location = "<?php echo $gm_lang_location; ?>";

var centermarker, Dmarker;
function onLoad() {
	var nowlat = opener.document.getElementById("gm_latitude").value;
	var nowlng = opener.document.getElementById("gm_longitude").value;
	var nowzoom = opener.document.getElementById("gm_zoom").value;

	var map = new GMap2( document.getElementById("map") );
	map.addControl(new GLargeMapControl());
	map.addControl(new GMapTypeControl());

	//center marker
	var center_icon = new GIcon();
	center_icon.image = "./images/cicon.png";
	center_icon.iconSize = new GSize(15, 15);
	center_icon.iconAnchor = new GPoint(8, 8);

	GEvent.addListener(map, "moveend", function() {
		var center = map.getCenter();
		var zl = map.getZoom();
		
		var latLngStr = sprintf( gm_lang_location , { lat:center.y, lng:center.x, zoom:zl} ) + '<br /><br />'
		latLngStr += '<input type="button" value="<?php echo $lang_button; ?>" onclick="func('+center.y+','+center.x+','+zl+')">';
		document.getElementById("message").innerHTML = latLngStr;

		//creat center marker
		map.removeOverlay( centermarker );
		centermarker = new GMarker( map.getCenter(), center_icon );
		map.addOverlay( centermarker );
		
		//Draggable marker
		map.removeOverlay( Dmarker );
		Dmarker = new GMarker( map.getCenter(), { draggable:true , bouncy:true , bounceGravity:0.5 } );
		map.addOverlay( Dmarker );
		GEvent.addListener( Dmarker, "dragend", function() {
			window.setTimeout( function() {
				map.panTo( Dmarker.getPoint() );
			}, 1000 );
		});
	});

	if( (nowlat != 0) || (nowlng != 0) || (nowzoom != 0) ){
		gm_default_latitude  = nowlat;
		gm_default_longitude = nowlng;
		gm_default_zoom      = nowzoom;
	}
	map.setCenter( new GLatLng( gm_default_latitude, gm_default_longitude ), Math.floor( gm_default_zoom ) );
}//end onLoad

function func( yyy , xxx , zzz ) {
	//xxx=Math.floor(xxx * 100000000)/100000000;
	//yyy=Math.floor(yyy * 100000000)/100000000;
	opener.document.getElementById( "gm_latitude" ).value = yyy;
	opener.document.getElementById( "gm_longitude" ).value = xxx;
	opener.document.getElementById( "gm_zoom" ).value = Math.floor( zzz );
	window.close();
}

//#xxx# of the character string is replaced by data
//by gijyutsuhyouron [Ajax] chap.5
function sprintf( template, obj ){
	var rslt = template;
	for( var Name in obj ){
		value = obj[Name];
		reg = new RegExp( "#" + Name + "#", "g" );
		rslt = rslt.replace( reg, value );
	}
	return rslt;
}

window.onload = onLoad;
window.onunload = GUnload;
//]]>
</script>
</head>
<body>
<h3><?php echo $lang_title; ?></h3>
<div id="map" style="width:98%; height: 480px"></div>
<br />
<?php echo $lang_default_location; ?><br />
<?php echo $gm_default_location; ?><br />
<?php echo $gm_lang_default_location; ?><br /><br />
<?php echo $lang_current_location; ?><br />
<div id="message"></div>
</body>
</html>

<?php
// --- raw HTML end ---

}
else
{

// --- raw HTML begin ---
?>
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:v="urn:schemas-microsoft-com:vml">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
<title>weblinks - <?php echo $lang_title; ?></title>
</head>
<body>
<h3><?php echo $lang_title; ?></h3>
<h4 style="color: #ff0000;">not set google map api key</h4>
</body>
</html>
<?php
// --- raw HTML end ---

}
exit();
?>